#!/usr/bin/env node

const path = require('path');
const { watchTree, MicroRunner } = require('./lib/utils');
const transform = require('babel-transform-dir');

const APP_DIR = process.cwd();
const SOURCE_DIR = path.join(APP_DIR, 'src');
const FANTOM_DIR = path.join(APP_DIR, '.fantom');
const BUILD_DIR = path.join(FANTOM_DIR, 'build');

const micro = new MicroRunner(BUILD_DIR, {
  microPath: path.resolve(process.cwd(), 'node_modules', '.bin', 'micro-dev'),
});

watchTree(SOURCE_DIR, () => {
  micro.run();
  transform(SOURCE_DIR, BUILD_DIR, {
    babel: {
      presets: ['env']
    },
    // Invokes whenever a file is transformed and written.
    onFile: (file) => {
      console.log(`${SOURCE_DIR}/${file} -> ${BUILD_DIR}/${file}`)
    }
  })
});
