const { spawn } = require('child_process');

module.exports = class MicroRunner {
  constructor(path, { microPath } = {}) {
    this.path = path;
    this.running = false;
    this.microPath = microPath;
  }

  run() {
    if (this.running) return;
    console.log(this.microPath);
    const micro = spawn(`${this.microPath}`, [`${this.path}/index.js`]);
    this.running = true;

    micro.stdout.on('data', (data) => console.log(`${data}`));
    micro.stderr.on('data', (data) => console.log(`stderr: ${data}`));

    micro.on('close', (code) => {
      console.log(`child process exited with code ${code}`);
    });
  }
}
