const watch = require('watch');

module.exports = class TreeWatcher {
  constructor(dir) {
    this.dir = dir;
    this.initialRunComplete = false;
  }

  watch(cb) {
    watch.watchTree(this.dir, (f, curr, prev) => {
      if (typeof f == 'object' && prev === null && curr === null) {
        this.initialRunComplete = true;
        cb();
      } else if (prev === null) {
        // f is a new file
        if (this.initialRunComplete) cb();
      } else if (curr.nlink === 0) {
        // f was removed
        if (this.initialRunComplete) cb();
      } else {
        // f was changed
        if (this.initialRunComplete) cb();
      }
    });
  }
}
